// ==UserScript==
// @name 	Sayka Board
// @author	Say26
// @description	Script add additional menu to the Ru-Board forums

// @include	http://forum.ru-board.com/post.cgi?action=*
// @include	http://www.forum.ru-board.com/post.cgi?action=new*
// @include	http://forum.ru-board.com/topic.cgi*
// @include	http://www.forum.ru-board.com/topic.cgi*
// @include	http://forum.ru-board.com/postings.cgi*
// @include	http://www.forum.ru-board.com/postings.cgi*
// ==/UserScript==

var sayka_version = '1.02';
var sayka_x_offset = 'a';
var sayka_y_offset = 'a';
var sayka_preview_hot_enabled = 0;
var sayka_preview_source = 'post'


var sayka_tr=0;
var sayka_td=0;
var sayka_active_td='';
var sayka_active_menu;
var sayka_active_tag;

var sayka_lists=0;
var sayka_active_list='';
	

function sayka_find_selection()
{
	if (document.selection.createRange().text)
	{
	var c = document.selection.createRange().duplicate();
	return c;
	}
return false;
}

function sayka_check_keypress(only)
{
	if (only==1)
	{
	if (event.shiftKey && event.keyCode == 13) return false;
	}
	else
	{
	if (event.keyCode == 27) sayka_hide_menu(sayka_active_menu);  
	if (event.shiftKey && event.keyCode == 13) {sayka_save(sayka_active_tag,sayka_active_menu); }
	}
}

function sayka_focus(menu)
{
	switch(sayka_active_menu)
	{
		case 'sayka_edit_simple_text':
		document.getElementById('sayka_simple_text_p1').focus();
		document.getElementById('sayka_simple_text_p1').focus();
		break;
				
		case 'sayka_edit_multi_text':
		document.getElementById('sayka_edit_text').focus();
		document.getElementById('sayka_edit_text').focus();
		break;	
	
		case undefined:
		document.getElementById('post').focus();
		document.getElementById('post').focus();
		break;	
	}
}

function sayka_start_moving(menu)
{
	sayka_x_offset = 'a';
	sayka_y_offset = 'a';
	if (event.pageY - document.getElementById(menu).style.top.replace('px','') <= 25)
	{
	document.addEventListener('mousemove', sayka_move_mouse, false);
	}
}
function sayka_move_mouse()
{
	document.getElementById("sayka_save").focus();
	var t = document.getElementById(sayka_active_menu).style.top.replace('px','');
	var l = document.getElementById(sayka_active_menu).style.left.replace('px','');
	var x = event.pageX;
	var y = event.pageY;
		
	if (sayka_x_offset == 'a') { sayka_x_offset=x-l; }
	if (sayka_y_offset == 'a') { sayka_y_offset=y-t; }
	x = x - sayka_x_offset;
	y = y - sayka_y_offset;
	document.getElementById(sayka_active_menu).style.top = y
	document.getElementById(sayka_active_menu).style.left = x
}

function sayka_stop_moving()
{
document.removeEventListener('mousemove',  sayka_move_mouse,  false);

//sayka_active_menu=undefined;
//sayka_active_tag = undefined;
}

function sayka_get_active()
{
var a;
	if (!sayka_active_td && !sayka_active_list) a = document.getElementById("post");
	else if (!sayka_active_td) a = sayka_active_list;
	else a = sayka_active_td;
return a;
}
function sayka_insert(text)
{
	post = sayka_get_active();
	var caretPos = post.caretPos;
	if (post.createTextRange && caretPos)
	{
		caretPos.text=text;
		//caretPos.select();
	}
	else
	{
		 post.value += text; 
	}
	if (sayka_preview_hot_status() == 'enabled') {sayka_preview_hot()};
caretPost = '';
document.getElementById("post").focus();
document.getElementById("post").focus();
}


function sayka_display_menu(menu, html, tag)
{
	
sayka_active_menu = menu;
sayka_active_tag = tag;
	if (document.getElementById(menu) == null)
		{
		var div = document.createElement("div");
		div.id = menu;
		div.style.position="absolute";
		div.style.display="block";		
		div.onmousedown = function() { sayka_active_menu = this.id;sayka_active_tag=tag;sayka_start_moving(menu); }
		div.onmouseup = function() { sayka_stop_moving(); }
		div.onmouseover = function() {  }
		
			var w;
		switch(menu)
		{
			case 'sayka_edit_simple_text':
			w = 370;
			break;
			
			case 'sayka_edit_multi_text':
			case 'sayka_edit_table':
			w = 560;
			break;
			
			case 'sayka_preview':
			w = 700;
			break;
			
			case 'sayka_edit_list':
			w = 370;
			break;
		}
		
		div.style.left = screen.availWidth/2 - w/2;
		div.style.top = document.body.scrollTop + screen.availHeight/2 - 200
		document.body.appendChild(div)
	}	
	else 
	{
		div = document.getElementById(menu);
		div.style.display='block';
	}
var text = '<table cellpadding=0 cellspacing=0 class="sayka_edit_textt"><input type="hidden" ><tr><td class="sayka_edit_text_top_td"><a href="http://forum.ru-board.com/topic.cgi?forum=5&topic=15888&start=1240#3"><b>Sayka Board v. '+sayka_version+'</a></td><td class="sayka_edit_text_top_td2">['+tag+']</td></tr>';
text += '<tr><td class="sayka_edit_text_middle_td" colspan=2>'+html+'</td></tr><tr><td class="sayka_edit_text_bottom_td" colspan=2>';
if (tag != 'preview')
{
	text += '<button class="sc" id="sayka_save" onClick="sayka_save(\''+tag+'\', \''+menu+'\')"><b>Save</b></button>';
	text += ' <button class="sc" onClick="sayka_hide_menu(\''+menu+'\')">Cancel</button>';
}
else if(tag == 'preview')
{
	text += '<button class="sc"  id="sayka_save" onClick="sayka_hide_preview()"><b>Ok</b></button> ';

	var t = sayka_preview_hot_enabled ? 'Disable Hot' : 'Enable Hot';
	
	text += '<button id="sayka_preview_switch_button" class="sc" onClick="sayka_switch_preview_hot()">'+t+'</button>  ';
	text += '<button class="sc" onClick="sayka_preview_update()">Update</button>';
	


}
text +='</td></tr></table>'

document.getElementById(menu).innerHTML=text;
sayka_focus(menu);
sayka_focus(menu);
document.addEventListener('keypress', sayka_check_keypress, false);
}

function sayka_hide_menu(menu)
{
if (menu == undefined) menu = sayka_active_menu;

	document.getElementById(menu).style.display = 'none';

	if (menu == 'sayka_edit_table')
	{		
		sayka_td = 0;
		sayka_tr = 0;
		sayka_active_td = undefined
	}
	
	if (menu == 'sayka_edit_list')
	{
		sayka_active_list = undefined
		sayka_lists = 0;
	}
document.body.removeChild(menu);
document.removeEventListener('keypress', sayka_check_keypress, false);
sayka_active_menu = undefined;
}



function sayka_save(tag, menu,from)
{
var p1,p2;
	if (menu == 'sayka_edit_multi_text' && document.getElementById("sayka_edit_text").value != '')
	{
		if (document.getElementById("sayka_edit_text_title") && document.getElementById("sayka_edit_text_title").value != '')
		sayka_insert('['+tag+'='+document.getElementById("sayka_edit_text_title").value+']'+document.getElementById("sayka_edit_text").value+'[/'+tag+']');
		else
		sayka_insert('['+tag+']'+document.getElementById("sayka_edit_text").value+'[/'+tag+']');
	}
	
	if (menu == 'sayka_edit_simple_text')
	{
	p1 = document.getElementById("sayka_simple_text_p1").value
	if (document.getElementById("sayka_simple_text_p2")) p2 = document.getElementById("sayka_simple_text_p2").value
	
		if (p1 != '' && (p2 && p2 != ''))
		{
			sayka_insert('['+tag+'='+document.getElementById("sayka_simple_text_p1").value+']');
			sayka_insert(document.getElementById("sayka_simple_text_p2").value+'[/'+tag+']');
		}
	
		if (p1 != '' && (p2 == '' || !p2))
		{
			sayka_insert('['+tag+']'+p1+'[/'+tag+']');
		}

	}
	
	if (menu == 'sayka_edit_table')
	{
		var html = sayka_make_table();
		
		sayka_td = 0;
		sayka_tr = 0;
		sayka_active_td = undefined
		sayka_insert('['+tag+']'+html+'[/'+tag+']');
		
	}
	
	if (menu == 'sayka_edit_list')
	{
		sayka_active_list = undefined;
		sayka_insert(sayka_make_list());
		sayka_lists = 0;
	}
	
sayka_hide_menu(menu);
}


	
function sayka_make_table()
{
var html='';
			for (var tr=1; tr<=sayka_tr; tr++)
		{
			if (tr != 1) { html += '[tr]'; }
			for (var td=1; td<=sayka_td; td++)
			{
				if (td != 1) { html += '[tab]'; }
				html += document.getElementById('sayka_table_content_'+tr+'_'+td).value;
			}
		}
		if (sayka_preview_hot_status() == 'enabled') sayka_preview_hot('[table]'+html+'[/table]');

return html;
}


function sayka_table_get_td(tr,td)
{
	return document.getElementById('sayka_table_content_'+tr+'_'+td);
}

function sayka_table_create_textarea(tr, td)
{
	var tra = tr-1;
	var e = document.createElement("textarea");
	e.id = 'sayka_table_content_'+tr+'_'+td;
	e.cols = document.getElementById('sayka_table_content_'+tra+'_'+td) ? document.getElementById('sayka_table_content_'+tra+'_'+td).cols : 20;
	e.rows = "5";
	e.onfocus = function() { sayka_active_td=this; }
	e.onkeyup = function() { if (sayka_preview_hot_status() == 'enabled') sayka_preview_hot('[table]'+sayka_make_table()+'[/table]'); }
	e.onkeypress = function () { return sayka_check_keypress(1); }
	return e;
}
function sayka_table_create_element(type, id, parent)
{
	var e = document.createElement(type);
	e.id = id;
	if (type == 'td') e.style= 'text-align: center';
	parent.appendChild(e);
	return e;
}


function sayka_table_exec(command, value)
{
	
var i, k;
var tr, td;
var table = document.getElementById("sayka_table");
//alert(table.innerHTML);
if (value == undefined) value = 1;
	if (command == 'minus_td')
	{
	var td_id;
			for(i=1; i<=sayka_tr; i++)
			{
			for(k=1; k<=value; k++)
			{			
			td_id = sayka_td-k+1;
			document.getElementById('tr_'+i).removeChild(document.getElementById('td_'+i+'_'+td_id));
			}
		}
	sayka_td -= value;
	document.getElementById("sayka_td_counter").value = sayka_td;		
	}
	
	if (command == 'plus_td')
	{
		var td_id;
			for(i=1; i<=sayka_tr; i++)
			{	
			tr = document.getElementById('tr_'+i);
		for(k=1;k<=value;k++) 
		{	
			td_id = sayka_td+k;
			if (td_id == 0) td_id = 1;
			td = sayka_table_create_element('td','td_'+i+'_'+td_id, tr);
			if(i == 1) td.innerHTML += '<button onClick="sayka_table_exec(\'minus_width\', '+td_id+')"><</button> <button onClick="sayka_table_exec(\'plus_width\', '+td_id+')">></button><br>';
	
			td.appendChild(sayka_table_create_textarea(i, td_id))
			
		}
			}
		sayka_td += value;
		document.getElementById("sayka_td_counter").value = sayka_td;
	}
		
	if (command == 'minus_tr')
	{
		for (i=1;i <= value; i++)
		{
			var tr_id = sayka_tr-i+1;
		table.removeChild(document.getElementById('tr_'+tr_id));
		}
		
		sayka_tr -= value;
		document.getElementById("sayka_tr_counter").value = sayka_tr;
	}
	
	if (command == 'plus_tr')
	{
		var tr_id;
		for(k=1; k<=value; k++)
		{
				tr_id = ++sayka_tr;
		tr = sayka_table_create_element('tr','tr_'+tr_id, table);
			for(i=1; i<=sayka_td; i++)
			{
			td = sayka_table_create_element('td','td_'+tr_id+'_'+i, tr);
			if(sayka_tr == 1) td.innerHTML += '<button onClick="sayka_table_exec(\'minus_width\', '+i+')"><</button> <button onClick="sayka_table_exec(\'plus_width\', '+i+')">></button><br>';
	
			td.appendChild(sayka_table_create_textarea(tr_id, i))
			}
		}
		
		document.getElementById("sayka_tr_counter").value = sayka_tr;
	}
	if (command == "set_td")
	{
		var n_td = sayka_td - document.getElementById("sayka_td_counter").value;
		if (n_td > 0)
		{
			sayka_table_exec('minus_td', n_td);
		}
		else if(n_td < 0)
		{
			sayka_table_exec('plus_td', -n_td);
		}
		
	}
	if (command == "set_tr")
	{
		var n_tr = sayka_tr - document.getElementById("sayka_tr_counter").value;
		if (n_tr > 0)
		{
			sayka_table_exec('minus_tr', n_tr);
		}
		else if(n_tr < 0)
		{
			sayka_table_exec('plus_tr', -n_tr);
		}
	}
	
	if (command == "plus_width")
	{
		for(i=1; i<=sayka_tr; i++)
		{		
			sayka_table_get_td(i, value).cols += 3;
		}
	}
	if (command == "minus_width")
	{
		for(i=1; i<=sayka_tr; i++)
		{		
			sayka_table_get_td(i, value).cols -= 3;
		}
	}
	
		
		if (sayka_preview_hot_status() == 'enabled') sayka_preview_hot('[table]'+sayka_make_table()+'[/table]');
}

function sayka_add_table()
{
	var html = '<table border=0 width="100%"><tr><td><input onkeyup="sayka_table_exec(\'set_td\')" type="text" size="3"  style="margin-left: 33px" id="sayka_td_counter"><br><input onkeyup="sayka_table_exec(\'set_tr\')" type="text" size="3" id="sayka_tr_counter"></td><td><center><button class="pm" onClick="sayka_table_exec(\'minus_td\'); return false;">-</button> <button class="pm" onClick="sayka_table_exec(\'plus_td\'); return false;">+</button></center></td></tr><tr><td><center><button class="pm" onClick="sayka_table_exec(\'minus_tr\'); return false;">-</button><br><br><button class="pm" onClick="sayka_table_exec(\'plus_tr\'); return false;">+</button></center></td><td noWrap><table id="sayka_table"></table></div></td></tr></table>';

	sayka_display_menu('sayka_edit_table', html, 'table');	
	sayka_table_exec('plus_td', 2);
	sayka_table_exec('plus_tr');
		document.getElementById('td_1_1').focus();
		document.getElementById('td_1_1').focus();
}

function sayka_list_exec(command, value)
{
var i;
if (value == undefined) value = 1;
if (value < 0) value = -value;
d = document.getElementById("sayka_edit_list_div");	
	switch(command)
	{
		case 'add':		
			for (i=1;i<=value;i++)
			{
			sayka_lists++;
			var t = document.createElement('textarea');			
			t.id = 'sayka_list_'+sayka_lists;
			t.onfocus = function() { sayka_active_list=this; }
			t.onkeyup = function() { if (sayka_preview_hot_status() == 'enabled') sayka_preview_hot(sayka_make_list()); }
			t.onkeypress = function () { return sayka_check_keypress(1); }
			t.cols='30';
			t.rows='3';
			d.appendChild(t);
			var br = document.createElement('br');
			br.id = 'sayka_list_br_'+sayka_lists;
			d.appendChild(br);			
			}
		document.getElementById("sayka_list_counter").value = sayka_lists;
		break;
		
		case 'delete':
			for (i=1;i<=value;i++)
			{
			d.removeChild(document.getElementById('sayka_list_'+sayka_lists));
			d.removeChild(document.getElementById('sayka_list_br_'+sayka_lists));
			sayka_lists--;
			}
		document.getElementById("sayka_list_counter").value = sayka_lists;
		break;
		
		case 'set':
		var n = document.getElementById("sayka_list_counter").value - sayka_lists;
		if (n > 0)
		{
			sayka_list_exec('add', n)
		}
		if (n < 0)
		{
			sayka_list_exec('delete', n)
		}
		break;
	}
	
		if (sayka_preview_hot_status() == 'enabled') sayka_preview_hot(sayka_make_list());
}

function sayka_make_list(list_type)
{
	var i, text;
	if (list_type != undefined) list = list_type;
	else
	list = document.getElementById('sayka_list_type').options[document.getElementById('sayka_list_type').selectedIndex].value;
	if (list != '')
	{
		text = '[list='+document.getElementById('sayka_list_type').options[document.getElementById('sayka_list_type').selectedIndex].value+']';
	}
	else
	{
		text = '[list]';
	}
	for (i=1; i<=sayka_lists;i++)
	{
		text += '[*]'+document.getElementById('sayka_list_'+i).value+'\n';
	}
	text += '[/list]';
return text;
}

function sayka_add_list()
{
	var html = '<div style="padding: 10px; text-align: center" id="sayka_edit_list_div"><select id="sayka_list_type" onChange="if (sayka_preview_hot_status() == \'enabled\') sayka_preview_hot(sayka_make_list(this.options[this.selectedIndex].value));"><option value="">Simple<option value="1">Numbered<option value="a">Lettered</select><br><br><button onClick="sayka_list_exec(\'delete\')">-</button><input id="sayka_list_counter" type="text" onkeyup="sayka_list_exec(\'set\')" size="3"><button onClick="sayka_list_exec(\'add\')">+</button><br><br></div>';
	sayka_display_menu('sayka_edit_list', html, 'list');
	sayka_list_exec('add');

		document.getElementById('sayka_list_1').focus();
		document.getElementById('sayka_list_1').focus();
		
}


function sayka_add_simple(tag, no_p2)
{
if (no_p2 == undefined) no_p2 = false;
	var text='', description = '';
	var s = sayka_find_selection() ? sayka_find_selection().text : ''
	if (s.indexOf('http') == -1)
	{
	description = s;
	}
	else
	{
	text = s;
	}
	var title = new Array();
	title['url'] = 'URL';
	title['user'] = 'Username';
	title['email'] = 'Email';
	title['img'] = 'Image url';
	var html = '<table class="sayka_simple_text"><tr><td>'
		html += title[tag]+'</td><td style="padding-left: 30px"><input type="text" id="sayka_simple_text_p1" size="40" value="'+text+'"></td></tr>';
if (!no_p2) 	html += '<tr><td>Description</td><td style="padding-left: 30px"><input type="text" id="sayka_simple_text_p2" size="40" value="'+description+'"></td></tr>';
	html += '</table>';
	sayka_display_menu('sayka_edit_simple_text', html, tag);

}

function sayka_add_multi(tag)
{
var s = sayka_find_selection();
//var text = s ? s.text : ''
//alert(event.ctrlKey);
	if (s)
	{
	if (tag == 'more' && event.ctrlKey)
	{
	sayka_display_menu('sayka_edit_multi_text', '<center><input type="text" style="margin: 10px;" size="70" id="sayka_edit_text_title"></center><textarea cols=90 rows=20 id="sayka_edit_text" style="border-top: 1px solid #808080">'+s.text+'</textarea>', tag);
	}
	else
	sayka_add_fast(s.text, tag);
	}

	else
	{
		if (tag == 'more')
		{
		sayka_display_menu('sayka_edit_multi_text', '<center><input type="text" style="margin: 10px;" size="70" id="sayka_edit_text_title"></center><textarea cols=90 rows=20 id="sayka_edit_text" style="border-top: 1px solid #808080"></textarea>', tag);
		}
	else
	sayka_display_menu('sayka_edit_multi_text', '<textarea cols=90 rows=20 id="sayka_edit_text"></textarea>', tag);
	}
}


function sayka_add_single(tag)
{
		sayka_insert('['+tag+']');
}
     

function sayka_add_pair(tag)
{
var s = sayka_find_selection();
	if (s)
	{
		s.text = '['+tag+']'+s.text+'[/'+tag+']';
		if (sayka_preview_hot_status() == 'enabled') {sayka_preview_hot();}
	}
	
	else
	{
		sayka_insert('['+tag+'][/'+tag+']');
	}
	
}

function sayka_add_fast(text, tag)
{
sayka_insert('['+tag+']'+text+'[/'+tag+']');
}


function sayka_add_simple_fast(tag, obj)
{
	var value = obj.options[obj.selectedIndex].value;

	obj.options[0].selected = 'true';
	
	var s = sayka_find_selection();
	if (s)
	{
		s.text = '['+tag+'='+value+']'+s.text+'[/'+tag+']';
		if (sayka_preview_hot_status() == 'enabled') {sayka_preview_hot();}
	}
	else
	{
		sayka_insert('['+tag+'='+value+'][/'+tag+']');
	}
	
}

function sayka_add_smile(smile)
{
	sayka_insert(' '+smile);
}


function sayka_show_smiles()
{
	if (document.getElementById("sayka_smiles").style.display == 'none')
	{
		document.getElementById("sayka_smiles").style.display = 'block';
	}
	else
	{
		document.getElementById("sayka_smiles").style.display = 'none'
	}
}




function sayka_show_preview()
{
var text = document.getElementById("post").value;
text = sayka_parse_text(text);
sayka_display_menu('sayka_preview', '<table bgColor="white" style=" padding: 4px"><tr><td class=dats bgcolor="white" valign="top" width="180"  rowspan="2" noWrap><a class=m><b>Sayka Board</b></a><br><br><img src="http://i.ru-board.com/avatars/private/Say26.gif" border=0><br><br>v. '+sayka_version+'</td><td bgcolor="white" class=tpc valign=top width=500 height=100%>Edit | Profile | Message | Quote <hr size=1 width=100% color=#999999><span class=post id="sayka_preview_text">'+text+'</span></td></tr><tr><td class="bottomline" bgcolor="white" noWrap><hr size=1 width=100% color=#999999><span class=tpc>Total messages: <b>0000</b> | Registration <b>00-00-0000</b> | <a class=tpc href="#11""><u>Sent:</u></a> <b>00:00 00-00-0000</b>  </span></td></tr><input type="hidden" id="sayka_preview_focus"/></table>','preview')
}

function sayka_hide_preview()
{
	document.getElementById("sayka_preview").style.display = 'none';
}

function sayka_preview_update()
{
	document.getElementById("sayka_preview_text").innerHTML = sayka_parse_text(sayka_get_active().value);
}

function sayka_preview_hot_status()
{	
	if (sayka_preview_hot_enabled == 1 && (document.getElementById("sayka_preview") && document.getElementById("sayka_preview").style.display == 'block'))
	{
		return 'enabled';
	}
return 'disabled';
}

function sayka_enable_preview_hot()
{
	sayka_preview_hot_enabled = 1;
	document.getElementById("post").onkeyup = function () { if (sayka_preview_hot_status() == 'enabled') sayka_preview_hot(); }
	sayka_preview_hot();
}

function sayka_disable_preview_hot()
{
	sayka_preview_hot_enabled = 0;
	document.getElementById("post").onkeyup = function () { }
	
}

function sayka_switch_preview_hot()
{
	if (document.getElementById("sayka_preview") && document.getElementById("sayka_preview").style.display == 'block')
	{
		var html = document.getElementById("sayka_preview_switch_button").innerHTML;
		if (html == 'Enable Hot')
		{
			document.getElementById("sayka_preview_switch_button").innerHTML = 'Disable Hot';
			sayka_enable_preview_hot();
		}
		else
		{
			document.getElementById("sayka_preview_switch_button").innerHTML = 'Enable Hot';
			sayka_disable_preview_hot();
		}
	}
}


function sayka_preview_hot(text)
{

  if (typeof(text) == 'undefined') 
  {
  	if ((document.getElementById("sayka_edit_table") && document.getElementById("sayka_edit_table").style.display != 'block') || !document.getElementById("sayka_edit_table")) 
  	text = document.getElementById("post").value;
  	else
  	text = '[table]'+sayka_make_table()+'[/table]'
  }
	if (document.getElementById("sayka_preview") && document.getElementById("sayka_preview").style.display == 'block')
	{
	text = sayka_parse_text(text);
	document.getElementById("sayka_preview_text").innerHTML = text;
	}
  	
}



function sayka_parse_text(text)
{

//------------------------\r\n--------------------------------------
while (text.indexOf("\r\n") != -1)
{
text = text.replace("\r\n", "[[sayka_rn]]");
}

//------------------------\r\n--------------------------------------
while (text.indexOf("\n") != -1)
{
text = text.replace("\n", "[[sayka_rn]]");
}


//---------------------html entities-----------------------------------


while (text.indexOf('"') != -1)	text = text.replace('"','&quot;');

while (text.indexOf("'") != -1)	text = text.replace("'",'&#039;');

while (text.indexOf("<") != -1)	text = text.replace("<",'&lt;');

while (text.indexOf(">") != -1)	text = text.replace(">",'&gt;');


//------------------------[no]--------------------------------------
	var No = new Array();
var n=1;
while(text.match(/\[no\].+\[\/no\]/))
{
No[n] = text.match(/\[no\](.+?)\[\/no\]/)[1];
text = text.replace(/\[no\](.+?)\[\/no\]/, '[[sayka_no_'+n+']]');
n++;
}
No = No.reverse()
// ----------------------------[hr] [br]-------------------
while (text.match(/\[(hr|br)\]/))	text = text.replace(/\[(hr|br)\]/,'<$1/>');


// -----------------------[table][tr][td]------------------------

while (text.indexOf('[table]') != -1)	text = text.replace('[table]', '<table cellpadding="3" cellspacing="0" bgcolor="#FFFFFF" width="75%" border="1" bordercolor="#EEEEEE"><tr class=lgf><td>');

while (text.indexOf('[tab]') != -1)	text = text.replace('[tab]', '</td><td>');

while (text.indexOf('[tr]') != -1)	text = text.replace('[tr]', '</td></tr><tr class=lgf><td>');

while (text.indexOf('[/table]') != -1)	text = text.replace('[/table]', '</td></tr></table>');


// -----------------------[color] [font] [size] --------------

while (text.match(/\[color=[a-zA-Z]+\].+\[\/color\]/)) text = text.replace(/\[color=([a-zA-Z]+)\](.+?)\[\/color\]/,'<font color="$1">$2</font>');
while (text.match(/\[font=[a-zA-Z\s]+\].+\[\/font\]/)) text = text.replace(/\[font=([a-zA-Z\s]+)\](.+?)\[\/font\]/,'<font face="$1">$2</font>');
while (text.match(/\[size=[0-9]+\].+\[\/size\]/)) text = text.replace(/\[size=([0-9]+)\](.+?)\[\/size\]/,'<font size="$1">$2</font>');

// ---------------------------[user]-----------------------------
while (text.match(/\[user=([a-zA-Z0-9]+)\]([^\[]+)\[\/user\]/)) text = text.replace(/\[user=([a-zA-Z0-9]+)\]([^\[]+)\[\/user\]/,'<a href="http://forum.ru-board.com/profile.cgi?action=show&member=$1">$2</a>');
while (text.match(/\[user\]([a-zA-Z0-9]+)\[\/user\]/)) text = text.replace(/\[user\]([a-zA-Z0-9]+)\[\/user\]/,'<a href="http://forum.ru-board.com/profile.cgi?action=show&member=$1">$1</a>');

// ---------------------------[url]-----------------------------
while (text.match(/\[url=([^\[]+)\].+\[\/url\]/)) text = text.replace(/\[url=([^\[]+)\](.+?)\[\/url\]/,'<a href="$1">$2</a>');

while (text.match(/\[url\]([^\[]+)\[\/url\]/)) text = text.replace(/\[url\]([^\[]+)\[\/url\]/,'<a href="$1">$1</a>');

// ---------------------------[email]-----------------------------
while (text.match(/\[email=[^\[]+\][^\[]+\[\/email\]/)) text = text.replace(/\[email=([^\[]+)\]([^\[]+)\[\/email\]/,'<a href="mailto:$1">$2</a>');
while (text.match(/\[email\][^\[]+\[\/email\]/)) text = text.replace(/\[email\]([^\[]+)\[\/email\]/,'<a href="mailto:$1">$1</a>');

// ---------------------------[image]-----------------------------
while (text.match(/\[img=[^\[]+\][^\[]+\[\/img\]/)) text = text.replace(/\[img=([^\[]+)\]([^\[]+)\[\/img\]/,'<a href="$1">$2</a>');
while (text.match(/\[img\][^\[]+\[\/img\]/)) text = text.replace(/\[img\]([^\[]+)\[\/img\]/,'<img src="$1" />');

// ------------------------[#] [more]-----------------------------
while (text.match(/\[#\].+\[\/#\]/)) text = text.replace(/\[#\](.+?)\[\/#\]/,'');
while (text.match(/\[more\](.+)\[\/more\]/)) text = text.replace(/\[more\].+?\[\/more\]/,'<a href="'+window.location+'#">More..</a>');

while (text.match(/\[more=[^\[]+\].+\[\/more\]/)) text = text.replace(/\[more=([^\[]+)\].+?\[\/more\]/,'<a href="'+window.location+'#">$1</a>');

// ------------------------[list]
while (text.match(/\[list=(1|a)\].+?\[\/list\]/)) text = text.replace(/\[list=(a|1)\](.+?)\[\/list\]/,'<ol type="$1">$2</ol>');
while(text.indexOf('[*]') != -1) text = text.replace('[*]','<li>');
while(text.indexOf('[list]') != -1) text = text.replace('[list]','<ul type="square">');
while(text.indexOf('[/list]') != -1) text = text.replace('[/list]','</ul>');


// -----------------------[code] [quote]-----------------------------
while (text.match(/\[code\].+\[\/code\]/)) text = text.replace(/\[code\](.+?)\[\/code\]/,'<font size="1"><b>Code:</b></font><table cellpadding="3" cellspacing="0" bgcolor="#FFFFFF" width="75%" border="1" bordercolor="#EEEEEE"><tr><td class=small>$1</td></tr></table>');
while (text.match(/\[(?:q|quote)\].+\[\/(?:q|quote)\]/)) text = text.replace(/\[(?:q|quote)\](.+?)\[\/(?:q|quote)\]/,'<font size="1"><b>Quote:</b></font><table cellpadding="3" cellspacing="0" bgcolor="#FFFFFF" width="75%" border="1" bordercolor="#EEEEEE"><tr><td class=small>$1</td></tr></table>');


// -----------------------[b] [i] [c] [sup] --------------------------------
while (text.match(/\[([a-zA-Z]+)\](.+?)\[\/[a-zA-Z]+\]/))
{
text = text.replace(/\[([a-zA-Z]+)\](.+?)\[\/[a-zA-Z]+\]/, '<$1>$2</$1>');
}

// ----------------------smiles--------------------------------------------
while (text.match(/\:[a-zA-Z_-]+\:/))
{
text = text.replace(/\:([a-zA-Z_-]+)\:/, '<img src="http://i.ru-board.com/s/$1.gif" /> ');
}
var a = new Array(':)', ';)',':D',':o');
var b = new Array('smile','wink','biggrin','redface');
for (var i=0; i<a.length;i++)
{
	while(text.indexOf(a[i]) != -1) 
	{
	text=text.replace(a[i], '<img src="http://i.ru-board.com/s/'+b[i]+'.gif" />');
	}
}

// -------------------------[no]------------------------------------
n--;n--;
while(text.match(/\[\[sayka_no_[0-9]+\]\]/))
{
text = text.replace(/\[\[sayka_no_[0-9]+\]\]/, No[n]);
n--;
}


//------------------------\r\n--------------------------------------
while (text.indexOf("[[sayka_rn]]") != -1)
{
text = text.replace("[[sayka_rn]]", "<br />");
}
return text;

}

function sayka_help(tag)
{
	var help = new Array();
	help['default'] = 'Sayka Board v. '+sayka_version+' - Opera menu for Ru-Board';
	help['b'] = 'Bold -  [b]text[/b]';
	help['i'] = 'Italic -  [i]text[/i]';
	help['u'] = 'Underlined -  [u]text[/u]';
	help['s'] = 'Small -  [small]text[/small]';
	help['strike'] = 'Striked -  [strike]text[/strike]';
	help['c'] = 'Centered -  [c]text[/c]';
	help['sup'] = 'Superscript -  [sup]text[/sup]';
	help['sub'] = 'Subscript -  [sub]text[/sub]';
	help['hr'] = 'Horizontal rule - [hr]';
	help['br'] = 'New String - [br]';
	help['font'] = 'Font - [font=font name]text[/font]';
	help['size'] = 'Font Size - [size=font size]text[/size]';
	help['color'] = 'Font Color - [color=font color]text[/color]';
	help['url'] = 'Link';
	help['email'] = 'Email';
	help['img'] = 'Link to image';
	help['user'] = 'Link to user profile';
	help['more'] = 'Hide text and create link to it';
	help['#'] = 'Hide text';
	help['q'] = 'Insert quote';
	help['code'] = 'Insert code';
	help['no'] = 'Cancel codes';
	help['table'] = 'Insert table';
	help['list'] = 'Add list';
	help['smiles'] = 'Show smiles panel';
	help['preview'] = 'Show message preview';
	document.getElementById("sayka_help").innerHTML = help[tag];
}





document.addEventListener(
  'load',
  function (e) {
  	//sayka_focus();
 // 	sayka_disable_preview_hot();
  	var colors = new Array('DeepSkyBlue', 'Darkcyan', 'Steelblue', 'Blue', 'Darkblue', 'Purple', 'Indigo', 'Orange', 'Red', 'Crimson', 'Darkred', 'Silver', 'Grey', 'Green', 'Darkgreen');
  	var fonts = new Array('Arial', 'Comic Sans MS', 'Courier New', 'Geneva', 'Georgia', 'Tahoma', 'Times', 'Trebuchet MS', 'Verdana');
  	var smiles_folder = 'E:/www/htdocs/say26/say26.free.fr/sayka/smiles/';
var sayka_menu = document.createElement("div");
sayka_menu.id = "sayka_menu";

sayka_menu.innerHTML += '<button style="display: none;"></button><button onClick="sayka_add_pair(\'b\'); return false;" class="sayka" onMouseOver="sayka_help(\'b\')" onMouseOut="sayka_help(\'default\')"><b>B</b></button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_pair(\'i\'); return false;"  class="sayka" onMouseOver="sayka_help(\'i\')" onMouseOut="sayka_help(\'default\')"><i>I</i></button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_pair(\'u\'); return false;"  class="sayka" onMouseOver="sayka_help(\'u\')" onMouseOut="sayka_help(\'default\')"> <u>U</u></button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_pair(\'small\'); return false;"  class="sayka" onMouseOver="sayka_help(\'s\')" onMouseOut="sayka_help(\'default\')"> s</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_pair(\'strike\'); return false;"  class="sayka" onMouseOver="sayka_help(\'strike\')" onMouseOut="sayka_help(\'default\')">S</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_pair(\'center\'); return false;"  class="sayka" onMouseOver="sayka_help(\'c\')" onMouseOut="sayka_help(\'default\')">C</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_pair(\'sup\'); return false;" class="sayka" onMouseOver="sayka_help(\'sup\')" onMouseOut="sayka_help(\'default\')">sup</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_pair(\'sub\'); return false;" class="sayka" onMouseOver="sayka_help(\'sub\')" onMouseOut="sayka_help(\'default\')">sub</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_single(\'br\'); return false;" class="sayka" onMouseOver="sayka_help(\'br\')" onMouseOut="sayka_help(\'default\')">br</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_single(\'hr\'); return false;" class="sayka" onMouseOver="sayka_help(\'hr\')" onMouseOut="sayka_help(\'default\')">hr</button>'
p = '<select onChange="sayka_add_simple_fast(\'font\', this); return false;" class="sayka" onMouseOver="sayka_help(\'font\')" onMouseOut="sayka_help(\'default\')"><option value="0">FONT';
for (var i=0; i<fonts.length; i++)
{
p +='<option value="'+fonts[i]+'">'+fonts[i]+'</option>';
}
sayka_menu.innerHTML += p;
p = '';
p = '<select onChange="sayka_add_simple_fast(\'color\', this); return false;" class="sayka" onMouseOver="sayka_help(\'color\')" onMouseOut="sayka_help(\'default\')"><option value="0">COLOR'
for (var i=0; i<colors.length; i++)
{
p +='<option value="'+colors[i]+'" style="color: '+colors[i]+'">'+colors[i]+'</option>';
}
sayka_menu.innerHTML += p;
sayka_menu.innerHTML += '</select><br><button onClick="sayka_add_simple(\'url\'); return false;" class="sayka" onMouseOver="sayka_help(\'url\')" onMouseOut="sayka_help(\'default\')">http</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_simple(\'email\'); return false;" class="sayka" onMouseOver="sayka_help(\'email\')" onMouseOut="sayka_help(\'default\')">@</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_simple(\'img\', true); return false;" class="sayka" onMouseOver="sayka_help(\'img\')" onMouseOut="sayka_help(\'default\')">img</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_simple(\'user\'); return false;" class="sayka" onMouseOver="sayka_help(\'user\')" onMouseOut="sayka_help(\'default\')">user</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_multi(\'more\'); return false;" class="sayka" onMouseOver="sayka_help(\'more\')" onMouseOut="sayka_help(\'default\')">more</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_multi(\'#\'); return false;"  class="sayka" onMouseOver="sayka_help(\'#\')" onMouseOut="sayka_help(\'default\')">#</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_multi(\'q\'); return false;" class="sayka" onMouseOver="sayka_help(\'q\')" onMouseOut="sayka_help(\'default\')">quote</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_multi(\'code\'); return false;" class="sayka" onMouseOver="sayka_help(\'code\')" onMouseOut="sayka_help(\'default\')">code</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_multi(\'no\'); return false;" class="sayka" onMouseOver="sayka_help(\'no\')" onMouseOut="sayka_help(\'default\')">no</button>'
sayka_menu.innerHTML += '<button onClick="sayka_add_table(); return false;" class="sayka" onMouseOver="sayka_help(\'table\')" onMouseOut="sayka_help(\'default\')">table</button>'

sayka_menu.innerHTML += '<select style="width: 97px" onChange="sayka_add_simple_fast(\'size\', this); return false;" class="sayka" onMouseOver="sayka_help(\'size\')" onMouseOut="sayka_help(\'default\')"><option value="0">SIZE<option value="1">1 - Small<option value="2">2 - Norm<option value="3">3 - Large<option value="4">4<option value="5">5<option value="6">6<option value="7">7 - Large</select>'
sayka_menu.innerHTML += '<br>';
sayka_menu.innerHTML += '<button onClick="sayka_add_list(); return false;" class="sayka" onMouseOver="sayka_help(\'list\')" onMouseOut="sayka_help(\'default\')">list</button>'
document.getElementById("post").parentNode.insertBefore(sayka_menu,document.getElementById("post"))

//--------------------------- Help Menu ---------------------//
var sayka_help = document.createElement("div");
sayka_help.id = "sayka_help";
sayka_help.innerHTML = "Sayka Board v. "+sayka_version+" - Opera menu for Ru-Board";
document.getElementById("sayka_menu").parentNode.insertBefore(sayka_help,document.getElementById("sayka_menu"))

//------------------------- Bottom Menu -----------------------//

var sayka_bottom_menu = document.createElement("div");
sayka_bottom_menu.id = "sayka_bottom_menu";
sayka_bottom_menu.innerHTML = '<button class="sayka" onClick="sayka_show_smiles(); return false;"onMouseOver="sayka_help(\'smiles\')" onMouseOut="sayka_help(\'default\')">Smiles</button>';
sayka_bottom_menu.innerHTML += '<button class="sayka" onClick="sayka_show_preview(); return false;"onMouseOver="sayka_help(\'preview\')" onMouseOut="sayka_help(\'default\')">Preview</button>';
document.getElementById("post").parentNode.insertBefore(sayka_bottom_menu,document.getElementById("post").nextSibling)

//--------------------------- Smiles Menu ---------------------//

var sayka_smiles = document.createElement("div");
sayka_smiles.id = "sayka_smiles";
sayka_smiles.style.display = 'none';
var smiles = new Array('smile', 'wink','beer','biggrin','super','pray','umnik','cranky','eek','thanks','ruboard','off','confused','shuffle','tease','up','down')
for (var i = 0; i<smiles.length; i++)
{
	sayka_smiles.innerHTML += '<img src="http://i.ru-board.com/s/'+smiles[i]+'.gif" onClick="sayka_add_smile(\':'+smiles[i]+':\')" style="cursor: hand; padding-right: 4px"/>';

}

document.getElementById("sayka_bottom_menu").parentNode.insertBefore(sayka_smiles,document.getElementById("sayka_bottom_menu").nextSibling)








  },
  false
);